
; Note: this is by no means optimized.  It is intended for importing the
;       sha.inc source and testing it against standard SHA Transformations

;;__opt486 equ 1

ifdef __opt486
        .486p
else
        .386p
endif
_TEXT   segment byte public use16 'CODE'
_TEXT   ends
DGROUP  group   _DATA,_BSS
        assume  cs:_TEXT,ds:DGROUP
_DATA   segment word public use16 'DATA'

initial_state label dword
  dd 67452301h, 0EFCDAB89h, 98BADCFEh, 10325476h, 0C3D2E1F0h
  dd 0        , 0

d@	label	byte
d@w	label	word
_DATA	ends
_BSS	segment word public use16 'BSS'
b@	label	byte
b@w	label	word
_BSS	ends
_TEXT	segment byte public use16 'CODE'
   ;	
   ;	void shsInit (shsInfo)
   ;	
	assume	cs:_TEXT,ds:DGROUP
_shsInit	proc	near
	push	bp
	mov	bp,sp
        mov     bx, word ptr [bp+4]
        mov     si, 7*4
@0@0:
        sub     si, 4
        js      short @0@1
        mov     eax, dword ptr initial_state[si]
        mov     dword ptr [bx][si], eax
        jmp     short @0@0
@0@1:
        pop     bp
        ret
_shsInit	endp
   ;	
   ;	void shsTransform (shsInfo)
   ;	
        assume  cs:_TEXT,ds:_TEXT
_shsTransform	proc	near
	push	bp
	mov	bp,sp
        push    ds
        cld
        mov     ax, cs
        mov     ds, ax
        mov     es, ax
        mov     di, offset state
        mov     si, word ptr [bp+4]
        mov     cx, (5+2+16)
        rep     movsd        
        call    SHATransform
        mov     si, offset state
        mov     di, word ptr [bp+4]
        mov     cx, 5
        rep     movsd
        pop     ds
        pop     bp
        ret
        include SHA.INC
state   label   dword
        dd      5 dup (?)
bcounts label   byte
        db      8 dup (?)
pool    label   dword
        dd      80 dup (?)
_shsTransform	endp

   ;
   ;	local void byteReverse (buffer, byteCount)
   ;	
	assume	cs:_TEXT,ds:DGROUP
byteReverse	proc	near
	push	bp
	mov	bp,sp
	sub	sp,8
	push	si
	push	di
   ;
   ;		LONG *buffer;
   ;		int byteCount;
   ;	{
   ;		LONG value;
   ;		int count;
   ;	
   ;		/*
   ;		 * Find out what the byte order is on this machine.
   ;		 * Big endian is for machines that place the most significant byte
   ;		 * first (eg. Sun SPARC). Little endian is for machines that place
   ;		 * the least significant byte first (eg. VAX).
   ;		 *
   ;		 * We figure out the byte order by stuffing a 2 byte string into a
   ;		 * short and examining the left byte. '@' = 0x40  and  'P' = 0x50
   ;		 * If the left byte is the 'high' byte, then it is 'big endian'.
   ;		 * If the left byte is the 'low' byte, then the machine is 'little
   ;		 * endian'.
   ;		 *
   ;		 *                          -- Shawn A. Clifford (sac@eng.ufl.edu)
   ;		 */
   ;	
   ;		/*
   ;		 * Several bugs fixed       -- Pat Myrto (pat@rwing.uucp)
   ;		 */
   ;	
   ;		if ((*(unsigned short *) ("@P") >> 8) == '@')
   ;	
	mov	ax,word ptr DGROUP:s@
	shr	ax,8
	cmp	ax,64
	je	short @3@226
   ;	
   ;			return;
   ;	
   ;		byteCount /= sizeof (LONG);
   ;	
	mov	ax,word ptr [bp+6]
	shr	ax,2
	mov	word ptr [bp+6],ax
   ;	
   ;		for (count = 0; count < byteCount; count++) {
   ;	
	mov	word ptr [bp-6],0
	mov	ax,word ptr [bp+4]
	mov	word ptr [bp-8],ax
	jmp	short @3@198
@3@114:
   ;	
   ;	#ifdef __TURBOC__
   ;	                value = _lrotl(buffer [count],16);
   ;	
ifndef __opt486
        mov     bx,word ptr [bp-8]
        mov     eax, dword ptr [bx]
        xchg    al, ah
        rol     eax, 16
        xchg    al, ah

;        push    16
;        push    dword ptr [bx]
;        call    near ptr __lrotl
;        add     sp,6
;        mov     word ptr [bp-2],dx
;        mov     word ptr [bp-4],ax
   ;
   ;	#else
   ;			value = (buffer [count] << 16) | (buffer [count] >> 16);
   ;	#endif
   ;			buffer [count] = ((value & 0xFF00FF00L) >> 8) | ((value & 0x00FF00FFL) << 8);
   ;	
;        mov     eax,dword ptr [bp-4]
;        and     eax,large 0FF00FF00h
;        shr     eax,8
;        mov     edx,dword ptr [bp-4]
;        and     edx,large 000FF00FFh
;        shl     edx,8
;        or      eax,edx
;        mov     bx,word ptr [bp-8]
else
	mov	bx,word ptr [bp-8]
        mov     eax,dword ptr [bx]
        bswap   eax
endif
	mov	dword ptr [bx],eax
	add	word ptr [bp-8],4
	inc	word ptr [bp-6]
@3@198:
	mov	ax,word ptr [bp-6]
	cmp	ax,word ptr [bp+6]
	jl	short @3@114
@3@226:
   ;	
   ;		}
   ;	}
   ;	
	pop	di
	pop	si
	leave	
	ret	
byteReverse	endp
   ;	
   ;	void shsUpdate (shsInfo, buffer, count)
   ;	
	assume	cs:_TEXT,ds:DGROUP
_shsUpdate	proc	near
	push	bp
	mov	bp,sp
	sub	sp,8
	push	si
	push	di
   ;	
   ;		SHS_INFO *shsInfo;
   ;		BYTE *buffer;
   ;		int count;
   ;	{
   ;		/* Update bitcount */
   ;		if ((shsInfo->countLo + ((LONG) count << 3)) < shsInfo->countLo)
   ;	
	movsx	eax,word ptr [bp+8]
	mov	dword ptr [bp-4],eax
	shl	eax,3
	mov	dword ptr [bp-8],eax
	mov	bx,word ptr [bp+4]
	add	eax,dword ptr [bx+20]
	cmp	eax,dword ptr [bx+20]
	jae	short @4@86
   ;	
   ;			 shsInfo->countHi++;	/* Carry from low to high bitCount */
   ;	
	inc	dword ptr [bx+24]
@4@86:
   ;	
   ;		shsInfo->countLo += ((LONG) count << 3);
   ;	
	mov	eax,dword ptr [bp-8]
	mov	bx,word ptr [bp+4]
	add	dword ptr [bx+20],eax
   ;	
   ;		shsInfo->countHi += ((LONG) count >> 29);
   ;	
	mov	eax,dword ptr [bp-4]
	shr	eax,29
	add	dword ptr [bx+24],eax
	jmp	short @4@142
@4@114:
   ;	
   ;	
   ;		/* Process data in SHS_BLOCKSIZE chunks */
   ;		while (count >= SHS_BLOCKSIZE) {
   ;			memcpy (shsInfo->data, buffer, SHS_BLOCKSIZE);
   ;	
	mov	di,word ptr [bp+4]
	add	di,28
	mov	si,word ptr [bp+6]
	mov	cx,32
	push	ds
	pop	es
	rep 	movsw	
   ;	
   ;			byteReverse (shsInfo->data, SHS_BLOCKSIZE);
   ;	
	push	64
	mov	ax,word ptr [bp+4]
	add	ax,28
	push	ax
	call	near ptr byteReverse
   ;	
   ;			shsTransform (shsInfo);
   ;	
	push	word ptr [bp+4]
	call	near ptr _shsTransform
	add	sp,6
   ;	
   ;			buffer += SHS_BLOCKSIZE;
   ;	
	add	word ptr [bp+6],64
   ;	
   ;			count -= SHS_BLOCKSIZE;
   ;	
	sub	word ptr [bp+8],64
@4@142:
	cmp	word ptr [bp+8],64
	jge	short @4@114
   ;	
   ;		}
   ;	
   ;		/*
   ;		 * Handle any remaining bytes of data.
   ;		 * This should only happen once on the final lot of data
   ;		 */
   ;		memcpy (shsInfo->data, buffer, count);
   ;	
	mov	di,word ptr [bp+4]
	add	di,28
	mov	si,word ptr [bp+6]
	mov	cx,word ptr [bp+8]
	shr	cx,1
	push	ds
	pop	es
	rep 	movsw	
	adc	cx,cx
	rep 	movsb	
   ;	
   ;	}
   ;	
	pop	di
	pop	si
	leave	
	ret	
_shsUpdate	endp
   ;	
   ;	void shsFinal (shsInfo)
   ;	
	assume	cs:_TEXT,ds:DGROUP
_shsFinal	proc	near
	push	bp
	mov	bp,sp
	sub	sp,8
	push	si
	push	di
   ;	
   ;		SHS_INFO *shsInfo;
   ;	{
   ;		int count;
   ;		LONG lowBitcount = shsInfo->countLo, highBitcount = shsInfo->countHi;
   ;	
	mov	bx,word ptr [bp+4]
	mov	eax,dword ptr [bx+20]
	mov	dword ptr [bp-4],eax
	mov	eax,dword ptr [bx+24]
	mov	dword ptr [bp-8],eax
   ;	
   ;	
   ;		/* Compute number of bytes mod 64 */
   ;		count = (int) ((shsInfo->countLo >> 3) & 0x3F);
   ;	
	mov	eax,dword ptr [bx+20]
	shr	eax,3
	and	ax,63
	mov	dx,ax
   ;	
   ;	
   ;		/*
   ;		 * Set the first char of padding to 0x80.
   ;		 * This is safe since there is always at least one byte free
   ;		 */
   ;		((BYTE *) shsInfo->data) [count++] = 0x80;
   ;	
	add	bx,dx
	mov	byte ptr [bx+28],128
	inc	dx
   ;	
   ;	
   ;		/* Pad out to 56 mod 64 */
   ;		if (count > 56) {
   ;	
	cmp	dx,56
	jle	short @5@86
   ;	
   ;			/* Two lots of padding:  Pad the first block to 64 bytes */
   ;			memset ((BYTE *) shsInfo->data + count, 0, 64 - count);
   ;	
	mov	cx,64
	sub	cx,dx
	mov	di,word ptr [bp+4]
	add	di,dx
	add	di,28
	xor	ax,ax
	push	ds
	pop	es
	shr	cx,1
	rep 	stosw	
	adc	cx,cx
	rep 	stosb	
   ;	
   ;			byteReverse (shsInfo->data, SHS_BLOCKSIZE);
   ;	
	push	64
	mov	ax,word ptr [bp+4]
	add	ax,28
	push	ax
	call	near ptr byteReverse
   ;	
   ;			shsTransform (shsInfo);
   ;	
	push	word ptr [bp+4]
	call	near ptr _shsTransform
	add	sp,6
   ;	
   ;	
   ;			/* Now fill the next block with 56 bytes */
   ;			memset (shsInfo->data, 0, 56);
   ;	
	mov	di,word ptr [bp+4]
	add	di,28
	xor	ax,ax
	push	ds
	pop	es
	mov	cx,28
	rep 	stosw	
	jmp	short @5@114
@5@86:
   ;	
   ;		} else
   ;			/* Pad block to 56 bytes */
   ;			memset ((BYTE *) shsInfo->data + count, 0, 56 - count);
   ;	
	mov	cx,56
	sub	cx,dx
	mov	di,word ptr [bp+4]
	add	di,dx
	add	di,28
	xor	ax,ax
	push	ds
	pop	es
	shr	cx,1
	rep 	stosw	
	adc	cx,cx
	rep 	stosb	
@5@114:
   ;	
   ;		byteReverse (shsInfo->data, SHS_BLOCKSIZE);
   ;	
	push	64
	mov	ax,word ptr [bp+4]
	add	ax,28
	push	ax
	call	near ptr byteReverse
   ;	
   ;	
   ;		/* Append length in bits and transform */
   ;		shsInfo->data [14] = highBitcount;
   ;	
	mov	bx,word ptr [bp+4]
	mov	eax,dword ptr [bp-8]
	mov	dword ptr [bx+84],eax
   ;	
   ;		shsInfo->data [15] = lowBitcount;
   ;	
	mov	eax,dword ptr [bp-4]
	mov	dword ptr [bx+88],eax
   ;	
   ;	
   ;		shsTransform (shsInfo);
   ;	
	push	bx
	call	near ptr _shsTransform
   ;	
   ;		byteReverse (shsInfo->data, SHS_DIGESTSIZE);
   ;	
	push	20
	mov	ax,word ptr [bp+4]
	add	ax,28
	push	ax
	call	near ptr byteReverse
	add	sp,10
   ;	
   ;	}
   ;	
	pop	di
	pop	si
	leave	
	ret	
_shsFinal	endp
_TEXT	ends
_BSS	segment word public use16 'BSS'
_h0	label	word
	db	4 dup (?)
_h1	label	word
	db	4 dup (?)
_h2	label	word
	db	4 dup (?)
_h3	label	word
	db	4 dup (?)
_h4	label	word
	db	4 dup (?)
_A	label	word
	db	4 dup (?)
_B	label	word
	db	4 dup (?)
_C	label	word
	db	4 dup (?)
_D	label	word
	db	4 dup (?)
_E	label	word
	db	4 dup (?)
	?debug	C E9
	?debug	C FA95020000
_BSS	ends
_DATA	segment word public use16 'DATA'
s@	label	byte
	db	'@P'
	db	0
_DATA	ends
_TEXT	segment byte public use16 'CODE'
;        extrn   __lrotl:near
	public	_shsInit
	public	_shsUpdate
	public	_shsFinal
_TEXT	ends
_s@	equ	s@
	public	_h0
	public	_h1
	public	_h2
	public	_h3
	public	_h4
	public	_A
	public	_B
	public	_C
	public	_D
	public	_E
_byteReverse	equ	byteReverse
	end
